﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace DynamicDecimalColumn
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.radGridView1.EnableFiltering = true;
            this.radGridView1.AutoSizeColumnsMode = GridViewAutoSizeColumnsMode.Fill;

            DynamicDecimalColumn column = new DynamicDecimalColumn("OwnerCode", "OwnerCode");
            column.DecimalPlaces = 0;
            column.Name = "OwnerCode";
            column.HeaderText = "OwnerCode";
            column.Width = 100;
            this.radGridView1.MasterTemplate.Columns.Add(column);

            using (this.radGridView1.DeferRefresh())
            {
                for (int i = 1; i < 6; i++)
                {
                    this.radGridView1.Columns.Add("Column " + i);
                }
                for (int i = 1; i < 21; i++)
                {
                    this.radGridView1.Rows.Add(i, i, "A " + i, "B " + i, "C " + i, "D " + i);
                }
            }
        }
    }

    public class DynamicDecimalColumn : GridViewDecimalColumn
    {
        public DynamicDecimalColumn(string fieldName, string attributeName)
            : base(fieldName)
        {
            AttributeName = attributeName;
            DataType = typeof(decimal);
        }

        protected override void Initialize()
        {
            base.Initialize();
        }

        public string AttributeName { get; set; }


        public override Type GetCellType(GridViewRowInfo row)
        {
            if (row is GridViewDataRowInfo)
            {
                return typeof(GridDataCellElement);
            }
            return base.GetCellType(row);
        }
    }
}
